unit Unit_Sys_Exemple;

{
Cett unit eszt une unit d'interface pour ShellExecute, elle permet de convertir
des actions en anglais, ou des modes d'affichages en chaine, et vice versa.

Elle peut donc tre utilise  chaque fois qu'un utilisateur doit paramtrer
ShellExecute.

Elle est aussi conue de faon modulable, pour accepter d'autres langages.

}
interface

uses Windows, Classes, SysUtils;

//Types

type
  TFileActions=(Open,Edit,Explore,Find,Print,Properties);
  TExtensionAction=set of TFileActions;
  TExtensions=(Directory,Executable,ShortCut,UrlShortCut,Any);
  TLanguage=(Default,French);
  TShow=(Show,Hide,Maximize,Minimize,NoActivate,MinNoActivate);

//Dclarations

function GetExtension(const Name:String):TExtensions;
function GetActions(const Extension:TExtensions;const Language:TLanguage):TStringList;
function GetActionString(const Action:TFileActions):String;
function GetSelectedAction(const Action:String;const Language:TLanguage):TFileActions;
function GetShow:TStringList;
function GetSelectedShow(const SelectedShow:String):TShow;
function GetSWSHow(const FileShow:TShow):Integer;

implementation

//Constantes

const ActionName:array[TLanguage,TFileActions] of ShortString=(('Open','Edit','Explore','Find','Print','Properties'),
                                                              ('Ouvrir','Editer','Explorer','Rechercher','Imprimer','Proprits'));
      ShowName:array[TShow] of ShortString=('Affich','Cach','Maximis','Minimis','Dsactiv','Minimis et dsactiv');
      SWShow:array[TShow] of Integer=(SW_SHOW,SW_HIDE,SW_MAXIMIZE,SW_MINIMIZE,SW_SHOWNA,SW_SHOWMINNOACTIVE);
      ExtensionName:array[TExtensions] of String[4]=('','.EXE','.LNK','.URL','');
      ExtensionActions:array[TExtensions] of TExtensionAction=([Open,Find,Explore],
                                                               [Open],
                                                               [Open,Properties],
                                                               [Open],
                                                               [Open,Edit,Print]);

//Fonctions

function GetExtension(const Name:String):TExtensions;
var Extension:TExtensions;
begin
Result:=Any;
for Extension:=Low(TExtensions) to High(TExtensions) do
  if (UpperCase(Name)=UpperCase(ChangeFileExt(Name,ExtensionName[Extension]))) and (Result=Any) then
    Result:=Extension;
end;

function GetActions(const Extension:TExtensions;const Language:TLanguage):TStringList;
var Action:TFileActions;
begin
Result:=TStringList.Create;
for Action:=Low(TFileActions) to High(TFileActions) do
  if Action in ExtensionActions[Extension] then
    Result.Add(ActionName[Language,Action]);
end;

function GetShow:TStringList;
var Show:TShow;
begin
Result:=TStringList.Create;
for Show:=Low(TShow) to High(TShow) do
  Result.Add(ShowName[Show]);
end;

function GetSelectedAction(const Action:String;const Language:TLanguage):TFileActions;
var FileAction:TFileActions;
begin
Result:=Open;
for FileAction:=Low(TFileActions) to High(TFileActions) do
  if ActionName[Language,FileAction]=Action then
    Result:=FileAction;
end;

function GetActionString(const Action:TFileActions):String;
begin
Result:=ActionName[Default,Action];
end;

function GetSelectedShow(const SelectedShow:String):TShow;
var FileShow:TShow;
begin
Result:=Show;
for FileShow:=Low(TShow) to High(TShow) do
  if ShowName[FileShow]=SelectedShow then
    Result:=FileShow;
end;

function GetSWSHow(const FileShow:TShow):Integer;
begin
Result:=SWShow[FileShow];
end;

end.
